// FileElement.cpp: Implementierung der Klasse CFileElement.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "FileElement.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CFileElement::CFileElement()
{
	m_strName		= "";
	m_nSize			= 0;
	m_tCreated		= CTime();
	m_tLastModified = CTime();
	m_bIsDirectory	= true;

	m_fPoints[0]	= 0.0f;
	m_fPoints[1]	= 0.0f;
	m_fPoints[2]	= 0.0f;
	m_fPoints[3]	= 0.0f;

	m_fColor[0]		= 0.0f;
	m_fColor[1]		= 0.0f;
	m_fColor[2]		= 0.0f;

	m_nDepth = 0;

	next.reserve(10);

	m_nMinSize = 4000000000;	// a 4 gigabyte-file
	m_nMaxSize = 0;
	m_tMinCreated = CTime::GetCurrentTime();
	m_tMaxCreated = CTime(1980, 1, 1, 0, 0, 0);
	m_tMinModified = CTime::GetCurrentTime();
	m_tMaxModified = CTime(1980, 1, 1, 0, 0, 0);
}

//////////////////////////////////////////////////////////////////////

CFileElement::CFileElement(CString strName, _int64 nSize, CTime tCreated, 
									CTime tLastModified, bool bIsDir)
{
	m_strName		= strName;
	m_nSize			= nSize;
	m_tCreated		= tCreated;
	m_tLastModified = tLastModified;
	m_bIsDirectory	= bIsDir;

	m_fPoints[0]	= 0.0f;
	m_fPoints[1]	= 0.0f;
	m_fPoints[2]	= 0.0f;
	m_fPoints[3]	= 0.0f;

	m_fColor[0]		= 0.0f;
	m_fColor[1]		= 0.0f;
	m_fColor[2]		= 0.0f;

	m_nDepth = 0;

	if (m_bIsDirectory) next.reserve(10);

	m_nMinSize = 4000000000;	// a 4 gigabyte-file
	m_nMaxSize = 0;
	m_tMinCreated = CTime::GetCurrentTime();
	m_tMaxCreated = CTime(1980, 1, 1, 0, 0, 0);
	m_tMinModified = CTime::GetCurrentTime();
	m_tMaxModified = CTime(1980, 1, 1, 0, 0, 0);
}

//////////////////////////////////////////////////////////////////////

CFileElement::~CFileElement()
{
	clear(this);
}

//////////////////////////////////////////////////////////////////////

bool CFileElement::add(CString strFilename, CString strRoot, CTime tCreation, 
			CTime tLastModified, _int64 nSize, bool bIsDir)
{
	CString strThisDir	= "";
	CString strSubDir	= "";
	CString strDir		= "";
	int found = false;

	if (!bIsDir) 
	{
		if (nSize < m_nMinSize) m_nMinSize = nSize;
		if (nSize > m_nMaxSize) m_nMaxSize = nSize;
		if (tCreation < m_tMinCreated) m_tMinCreated = tCreation;
		if (tCreation > m_tMaxCreated) m_tMaxCreated = tCreation;
		if (tLastModified < m_tMinModified) m_tMinModified = tLastModified;
		if (tLastModified > m_tMaxModified) m_tMaxModified = tLastModified;
	}

	char *token = strtok(strRoot.GetBuffer(strRoot.GetLength()), "\\");
	while (token != NULL)
	{
		if (!found)
		{
			strThisDir += CString(token);
			if (strThisDir.Compare(m_strName) == 0) found = true;
			strThisDir += "\\";
		}
		else
		{
			if (strSubDir == "") strDir = CString(token);
			strSubDir += CString(token) + "\\";
		}

		// next token
		token = strtok(NULL, "\\");
	}
	
	if (strSubDir == "")
	{
		// create file-element and store it
		CFileElement *fe = new CFileElement(strFilename, nSize, tCreation, 
										tLastModified, bIsDir);
		next.push_back(fe);
		m_nSize += nSize;
	}
	else
	{
		for (int i = 0; i < next.size(); i++)
		{
			CFileElement *fe = (CFileElement *) next.at(i);
			if (fe->m_strName == strDir) 
			{
				fe->add(strFilename, strSubDir, tCreation, tLastModified, nSize, bIsDir);
				m_nSize += nSize;
			}
		}
	}

	return true;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::clear()
{
	clear(this);
	m_nDepth = 0;
}

//////////////////////////////////////////////////////////////////////

CFileElement* CFileElement::get(CString strFilename)
{
	return NULL;
}

//////////////////////////////////////////////////////////////////////

CFileElement* CFileElement::get(float x1, float y1, float x2, float y2)
{
	return NULL;
}

//////////////////////////////////////////////////////////////////////

int CFileElement::getMiddleChildID(int nMin, int nMax)
{
	if ((nMin > nMax) || (nMin < 0) || (nMax > next.size() - 1))
		return -1;
	else
		return (int) ((nMin + nMax) / 2) ;
}

//////////////////////////////////////////////////////////////////////

int CFileElement::getLargestChildID(int nMin, int nMax)
{
	if ((nMin > nMax) || (nMin < 0) || (nMax > next.size() - 1))
		return -1;
	else
	{
		_int64 nSize = -1;
		int nIndex = -1;

		for (int i = nMin; i <= nMax; i++)
		{
			if (next.at(i)->m_nSize > nSize)
			{
				nSize = next.at(i)->m_nSize;
				nIndex = i;
			}
		}
		return nIndex;
	}
}

//////////////////////////////////////////////////////////////////////

int CFileElement::getDepth(CFileElement *fe, int depth)
{
	if (depth > m_nDepth) m_nDepth = depth;
	
	if (!fe->m_bIsDirectory) return m_nDepth;
	
	for (int i = 0; i < fe->next.size(); i++)
	{
		(void) getDepth(fe->next.at(i), depth + 1);
	}

	return m_nDepth;
}

//////////////////////////////////////////////////////////////////////

std::vector<CFileElement *> *CFileElement::getDirectory()
{
	return &next;
}

//////////////////////////////////////////////////////////////////////

bool CFileElement::remove(CString strFilename)
{
	return false;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CFileElement::setRoot(CString strName)
{
	m_strName		= strName;
	m_bIsDirectory	= true;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setName(CString strName)
{
	m_strName = strName;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setCreated(CTime tTime)
{
	m_tCreated = tTime;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setLastModified(CTime tTime)
{
	m_tLastModified = tTime;	
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setSize(int nSize)
{
	if (nSize < 0) return;
	else m_nSize = nSize;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setIsDirectory(bool bDirectory)
{
	m_bIsDirectory = bDirectory;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setPoints(float x1, float y1, float x2, float y2)
{
	m_fPoints[0] = x1;
	m_fPoints[1] = y1;
	m_fPoints[2] = x2;
	m_fPoints[3] = y2;
}

//////////////////////////////////////////////////////////////////////

void CFileElement::setColor(float cRed, float cGreen, float cBlue)
{
	m_fColor[0] = cRed;
	m_fColor[1] = cGreen;
	m_fColor[2] = cBlue;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

CFileElement* CFileElement::findElementAt(CFileElement *fe, float x, float y, int nDepth, int nCurrDepth)
{
	if ((fe->m_fPoints[0] <= x) && (fe->m_fPoints[1] <= y) &&
		(fe->m_fPoints[2] >= x) && (fe->m_fPoints[3] >= y))
	{
		for (int i = 0; i < fe->next.size(); i++)
		{
			CFileElement *elem = (CFileElement *) fe->next.at(i);
			if ((elem->m_fPoints[0] <= x) && (elem->m_fPoints[1] <= y) &&
				(elem->m_fPoints[2] >= x) && (elem->m_fPoints[3] >= y) &&
				(nCurrDepth < nDepth))
			{
				return findElementAt(elem, x, y, nDepth, nCurrDepth + 1);
			}
		}
		
		return fe;
	}
	return NULL;
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CFileElement::printTree(CFileElement *fe, int level)
{
	for (int i = 0; i < level; i++) TRACE("\t");
	TRACE("%s - %I64d byte\n", fe->m_strName, fe->m_nSize);

	for (int j = 0; j < fe->next.size(); j++)
	{
		printTree((CFileElement *) fe->next.at(j), level + 1);
	}
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CFileElement::randomizeSize(CFileElement *fe)
{
	int nRandom = rand();
	float dSignum = 1.0f;
	if ((nRandom % 2) == 1) dSignum = -1.0f;
	// 10% change
	float randomFactor = 1.0f + (float) rand() / (RAND_MAX * 5.0f) * dSignum;

	fe->m_nSize = (_int64) (fe->m_nSize * randomFactor);

	if (!fe->m_bIsDirectory)
	{
		if (fe->m_nSize > m_nMaxSize) m_nMaxSize = fe->m_nSize;
		if (fe->m_nSize < m_nMinSize) m_nMinSize = fe->m_nSize;
	}

	for (int i = 0; i < fe->next.size(); i++)
	{
		randomizeSize(fe->next.at(i));
	}
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

_int64 CFileElement::recalculateSize(CFileElement *fe)
{
	if (fe->m_bIsDirectory)
	{
		_int64 nSize = 0;
		for (int i = 0; i < fe->next.size(); i++)
		{	
			nSize += recalculateSize(fe->next.at(i));
		}
		fe->m_nSize = nSize;
	}
	return fe->m_nSize;
}

//////////////////////////////////////////////////////////////////////
///private////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CFileElement::clear(CFileElement *fe, int nLevel)
{
	if (fe == NULL) return;

	// clear main attributes;
	fe->m_strName	= "";
	fe->m_nSize		= 0;

	while (!fe->next.empty()) 
	{
		CFileElement *f = (CFileElement *) fe->next.at(0);
		fe->next.erase(fe->next.begin());
		clear(f, nLevel + 1);
	}
	fe->next.clear();
	if (nLevel != 0)
	{
		delete fe;
	}
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////