#if !defined(AFX_OPENGL_H__EBE74B23_814F_4B3C_8706_A8B6CE8A4786__INCLUDED_)
#define AFX_OPENGL_H__EBE74B23_814F_4B3C_8706_A8B6CE8A4786__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OpenGL.h : Header-Datei
//

#include <GL/gl.h>					// OpenGL32 library header
#include <GL/glu.h>					// GLu32 library header
#include <GL/glut.h>				// GLut32 library header

#include "Renderer.h"
#include "FileElement.h"
#include <vector>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// Fenster COpenGL 

class COpenGL : public CWnd
{
// Konstruktion
public:
	COpenGL(CWnd *pParent);
	CWnd  *m_pParent;

// Attribute
protected:
	
	HGLRC m_hGLContext;				// for OpenGL drawing routine
	float scale;					// scaling factor
	CRenderer *renderer;			// the Render-engine

	short m_nTexWidth;				// Texture width
	short m_nTexHeight;				// Texture height
	short m_nTexDepth;				// Texture color-Depth
	bool m_bTexValid;				// Texture valid?
	GLuint m_nTexID;				// the Texture-ID

	int m_nCurrDepth;

public:
	void ViewOrtho(GLsizei w, GLsizei h);			//	size
	void ViewPerspective();							// aspect ratio

	void Resize();

	void Randomize();

	// pushed through methods
	inline void render()									{	renderer->render();							}
	inline void setFileElement(CFileElement *fe)			{	renderer->setFileElement(fe);				}
	inline void setRenderType(CRenderer::RENDERTYPE rt)		{	renderer->setRenderType(rt);				}
	inline void setMinColor(float dR, float dG, float dB)	{	renderer->setMinColor(dR, dG, dB);			}
	inline void setMaxColor(float dR, float dG, float dB)	{	renderer->setMaxColor(dR, dG, dB);			}
	inline void setColAttribute(CRenderer::COLATTRIBUTE ca)	{	renderer->setColorAttribute(ca);			}

	inline void setDepth(int nDepth)						{	m_nCurrDepth = nDepth; m_bTexValid = false; }

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(COpenGL)
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~COpenGL();

// Implementierung
protected:
	void GLresize(GLsizei width, GLsizei height);
	void GLinit();
	BOOL MySetPixelFormat(HDC hDC);

	// create an empty Texture for later use
	GLuint createEmptyTexture(short width, short height, short depth);

	// setup environment for texture-rendering and call renderScene
	void renderSceneToTexture(short width, short height);

	// just draw the scene
	void renderScene();

	// draw a single FileElement
	void drawFileElement(CFileElement *fe, int nDepth);

	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	//{{AFX_MSG(COpenGL)
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_OPENGL_H__EBE74B23_814F_4B3C_8706_A8B6CE8A4786__INCLUDED_


