// Panel.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OTM.h"
#include "OTMDlg.h"
#include "Panel.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPanel 


CPanel::CPanel(CWnd* pParent /*=NULL*/)
: CDialog(CPanel::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPanel)
	//}}AFX_DATA_INIT

	m_pParent = pParent;

	m_cMinCol = 0x0;
	m_cMaxCol = 0xffffff;

	// we want a modeless dialog
	BOOL ret = Create(IDD_PANEL,pParent);
	if(!ret) AfxMessageBox("Error creating Panel");

	// get the size set in the designer
	CRect rThis;
	GetWindowRect(rThis);

	// get client area of the parent window
	CRect rParent;
	m_pParent->GetClientRect(rParent);

	SetWindowPos(NULL,						// placement-order handle
	rParent.right-rThis.Width(),			// horizontal position
                 0,							// vertical position
                 rThis.Width(),				// width
                 rParent.Height(),			// height
                 SWP_SHOWWINDOW);			// window-positioning options);

	this->SetTimer(0, 50, NULL);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

CPanel::~CPanel() 
{ 
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPanel)
	DDX_Control(pDX, IDC_BUTTON_COLOR_MIN, m_btnColorMin);
	DDX_Control(pDX, IDC_BUTTON_COLOR_MAX, m_btnColorMax);
	DDX_Control(pDX, IDC_SL_HIERARCHY, m_slHierarchy);
	DDX_Control(pDX, IDC_EDIT_FILE_ATTRIBUTES, m_editFileAttribute);
	DDX_Control(pDX, IDC_CMB_COLOR_BY_ATTR, m_comboColorByAttribute);
	DDX_Control(pDX, IDC_BTN_RANDOM, m_btnRandomize);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CPanel, CDialog)
	//{{AFX_MSG_MAP(CPanel)
	ON_BN_CLICKED(IDC_BTN_RANDOM, OnBtnRandom)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_PIVOT_BY_MIDDLE, OnRadioPivotByMiddle)
	ON_BN_CLICKED(IDC_RADIO_PIVOT_BY_SIZE, OnRadioPivotBySize)
	ON_BN_CLICKED(IDC_RADIO_SLICE_AND_DICE, OnRadioSliceAndDice)
	ON_BN_CLICKED(IDC_RADIO_SQUARIFIED, OnRadioSquarified)
	ON_CBN_SELCHANGE(IDC_CMB_COLOR_BY_ATTR, OnSelchangeCmbColorByAttr)
	ON_BN_CLICKED(IDC_BUTTON_COLOR_MIN, OnButtonColorMin)
	ON_BN_CLICKED(IDC_BUTTON_COLOR_MAX, OnButtonColorMax)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BOOL CPanel::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CButton *btn;
	btn = (CButton *) GetDlgItem(IDC_RADIO_SLICE_AND_DICE);
	btn->SetCheck(1);
	btn = (CButton *) GetDlgItem(IDC_RADIO_SQUARIFIED);
	btn->SetCheck(0);
	btn = (CButton *) GetDlgItem(IDC_RADIO_PIVOT_BY_MIDDLE);
	btn->SetCheck(0);
	btn = (CButton *) GetDlgItem(IDC_RADIO_PIVOT_BY_SIZE);
	btn->SetCheck(0);

	m_comboColorByAttribute.SetCurSel(3);  // SIZE

	ActivateControls(false);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::ActivateControls(bool bActivate)
{
	// En- & Disable Radio-Buttons
	CButton *btn;
	btn = (CButton *) GetDlgItem(IDC_RADIO_SLICE_AND_DICE);
	btn->EnableWindow(bActivate);
	//btn = (CButton *) GetDlgItem(IDC_RADIO_SQUARIFIED);
	//btn->EnableWindow(bActivate);
	btn = (CButton *) GetDlgItem(IDC_RADIO_PIVOT_BY_MIDDLE);
	btn->EnableWindow(bActivate);
	btn = (CButton *) GetDlgItem(IDC_RADIO_PIVOT_BY_SIZE);
	btn->EnableWindow(bActivate);

	// set common Controls
	m_btnRandomize.EnableWindow(bActivate);
	m_comboColorByAttribute.EnableWindow(bActivate);
	m_slHierarchy.EnableWindow(bActivate);
	m_btnColorMin.EnableWindow(bActivate);
	m_btnColorMax.EnableWindow(bActivate);

	// ... and update GUI
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::Resize()
{
	CRect r;
	m_pParent->GetClientRect(&r);
	r.left = r.right - 220;
	SetWindowPos(NULL, r.left, r.top, r.Width(), r.Height(), SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::WriteFileElementInfo(CFileElement *fe)
{
	CString str;
	CString strSize;
	strSize.Format("%1.1f", fe->getSize() / 1024.0f);

	str  = "Name: " + fe->getName() + "\r\n";
	str += "Size: " + strSize + " kB\r\n";
	str += "Created: " + fe->getCreated().Format( "%A, %B %d, %Y" ) + "\r\n";
	str += "Modified: " + fe->getLastModifed().Format( "%A, %B %d, %Y" ) + "\r\n";
	//TRACE(str);

	m_editFileAttribute.SetWindowText(str);
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::SetScrollingRange(int nMax)
{
	m_slHierarchy.SetRange(0, nMax, true);
	m_slHierarchy.SetPos(nMax);
	CStatic *pStatic = (CStatic *) GetDlgItem(IDC_STATIC_LEVEL);
	CString str;
	str.Format("Level: %d", nMax);
	pStatic->SetWindowText(str);

	((COTMDlg *) m_pParent)->m_opengl->setDepth(nMax);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::SetColor(int nDlgID, COLORREF rColor)
{
	CStatic *pStatic = (CStatic *) GetDlgItem(nDlgID);
	
	if (pStatic)
	{
		// fetch CDC and set Background;
		CDC* pDC = pStatic->GetDC();

		if (pDC != NULL)
		{
			CBrush br(rColor);
			CRect r;
			pStatic->GetClientRect(&r);
			pDC->FillRect(r, &br);

			ReleaseDC(pDC);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnBtnRandom() 
{
	((COTMDlg *) m_pParent)->m_opengl->Randomize();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// update label
	CStatic *pStatic = (CStatic *) GetDlgItem(IDC_STATIC_LEVEL);
	CString str;
	str.Format("Level: %d", m_slHierarchy.GetPos());
	pStatic->SetWindowText(str);

	((COTMDlg *) m_pParent)->m_opengl->setDepth(m_slHierarchy.GetPos());

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnRadioPivotByMiddle() 
{
	((COTMDlg *) m_pParent)->m_opengl->setRenderType(CRenderer::PIVOT_BY_MIDDLE);
	((COTMDlg *) m_pParent)->m_opengl->render();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnRadioPivotBySize() 
{
	((COTMDlg *) m_pParent)->m_opengl->setRenderType(CRenderer::PIVOT_BY_SIZE);
	((COTMDlg *) m_pParent)->m_opengl->render();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnRadioSliceAndDice() 
{
	((COTMDlg *) m_pParent)->m_opengl->setRenderType(CRenderer::SLICE_AND_DICE);
	((COTMDlg *) m_pParent)->m_opengl->render();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnRadioSquarified() 
{
	((COTMDlg *) m_pParent)->m_opengl->setRenderType(CRenderer::SQUARIFIED);
	((COTMDlg *) m_pParent)->m_opengl->render();
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


void CPanel::OnSelchangeCmbColorByAttr() 
{
	CString strSelection;

	m_comboColorByAttribute.GetLBText(
		m_comboColorByAttribute.GetCurSel(), strSelection);

	if (strSelection.Compare("Creation") == 0)
	{
		((COTMDlg *) m_pParent)->m_opengl->setColAttribute(CRenderer::CREATION);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}
	else if (strSelection.Compare("Last Modified") == 0)
	{
		((COTMDlg *) m_pParent)->m_opengl->setColAttribute(CRenderer::MODIFIED);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}
	else if (strSelection.Compare("Random") == 0)
	{
		((COTMDlg *) m_pParent)->m_opengl->setColAttribute(CRenderer::RANDOM);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}
	else if (strSelection.Compare("Size") == 0)
	{
		((COTMDlg *) m_pParent)->m_opengl->setColAttribute(CRenderer::SIZE);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}
	else
	{
		TRACE("Error: Undefined Selection");
	}
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnButtonColorMin() 
{
	CColorDialog *pColDlg = new CColorDialog();

	if (pColDlg->DoModal() == IDOK)
	{
		SetColor(IDC_STATIC_COLOR_MIN, pColDlg->GetColor());
		m_cMinCol = pColDlg->GetColor();

		int nRed	= 0xff & pColDlg->GetColor();
		int nGreen	= (0xff00 & pColDlg->GetColor()) >> 8;
		int nBlue	= (0xff0000 & pColDlg->GetColor()) >> 16;

		float dRed		= (float) nRed   / 255.0f;
		float dGreen	= (float) nGreen / 255.0f;
		float dBlue		= (float) nBlue  / 255.0f;

		((COTMDlg *) m_pParent)->m_opengl->setMinColor(dRed, dGreen, dBlue);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}

	delete pColDlg;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CPanel::OnButtonColorMax() 
{
	CColorDialog *pColDlg = new CColorDialog();

	if (pColDlg->DoModal() == IDOK)
	{
		SetColor(IDC_STATIC_COLOR_MAX, pColDlg->GetColor());
		m_cMaxCol = pColDlg->GetColor();

		int nRed	= 0xff & pColDlg->GetColor();
		int nGreen	= (0xff00 & pColDlg->GetColor()) >> 8;
		int nBlue	= (0xff0000 & pColDlg->GetColor()) >> 16;

		float dRed		= (float) nRed   / 256.0f;
		float dGreen	= (float) nGreen / 256.0f;
		float dBlue		= (float) nBlue  / 256.0f;

		((COTMDlg *) m_pParent)->m_opengl->setMaxColor(dRed, dGreen, dBlue);
		((COTMDlg *) m_pParent)->m_opengl->render();
	}

	delete pColDlg;	
}

/////////////////////////////////////////////////////////////////////////////

void CPanel::OnTimer(UINT nIDEvent) 
{
	SetColor(IDC_STATIC_COLOR_MIN, m_cMinCol);
	SetColor(IDC_STATIC_COLOR_MAX, m_cMaxCol);

	CDialog::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////EOF
